commit 7e26e4fbd4ee618dd991c6bbf3c5403aa90d2192
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Fri Aug 7 20:29:11 2020 +0100

    libstdc++: Fix ambiguous comparisons in __gnu_debug::bitset [PR 96303]
    
    With -pedantic the debug mode bitset has an ambiguous equality
    comparison operator, because it tries to compare the non-debug base to
    the debug object. The base object can be converted to another debug
    bitset, making the same operator== a candidate again.
    
    The fix is to do the comparison on both base objects, so the operator
    for the derived type isn't a candidate.
    
    For the inequality operator the same change should be done, but that
    operator can be removed entirely for C++20 because it can be synthesized
    by the compiler.
    
    I don't think either equality or inequality operators are really needed,
    because the public _GLIBCXX_STD_C::bitset base class cam always be
    compared using its own comparison operators. I'm not changing that here
    though.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/96303
            * include/debug/bitset (bitset::operator==): Call _M_base() on
            right operand.
            (bitset::operator!=): Likewise, but don't define it at all when
            default comparisons are supported by the compiler.
            * testsuite/23_containers/bitset/operations/96303.cc: New test.
    
    (cherry picked from commit de1e3b8795e507c3cfa5b62984272628ca62a9bd)

diff --git a/libstdc++-v3/include/debug/bitset b/libstdc++-v3/include/debug/bitset
index fb498012605..1b8dc6d422c 100644
--- a/libstdc++-v3/include/debug/bitset
+++ b/libstdc++-v3/include/debug/bitset
@@ -353,11 +353,13 @@ namespace __debug
 
       bool
       operator==(const bitset<_Nb>& __rhs) const _GLIBCXX_NOEXCEPT
-      { return _M_base() == __rhs; }
+      { return _M_base() == __rhs._M_base(); }
 
+#if __cpp_impl_three_way_comparison < 201907L
       bool
       operator!=(const bitset<_Nb>& __rhs) const _GLIBCXX_NOEXCEPT
-      { return _M_base() != __rhs; }
+      { return _M_base() != __rhs._M_base(); }
+#endif
 
       using _Base::test;
       using _Base::all;
diff --git a/libstdc++-v3/testsuite/23_containers/bitset/operations/96303.cc b/libstdc++-v3/testsuite/23_containers/bitset/operations/96303.cc
new file mode 100644
index 00000000000..ab31e3c47d5
--- /dev/null
+++ b/libstdc++-v3/testsuite/23_containers/bitset/operations/96303.cc
@@ -0,0 +1,31 @@
+// Copyright (C) 2020 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++2a -pedantic" }
+// { dg-do compile { target c++2a } }
+
+#include <debug/bitset>
+
+bool
+test01()
+{
+  __gnu_debug::bitset<1> b;
+  // PR libstdc++/96303
+  bool eq = b == b;
+  bool ne = b != b;
+  return eq && !ne;
+}

